import click

from .add_idps_to_storage_gateway import add_idps_to_storage_gateway
from .add_globus_oidc import add_globus_oidc
from .add_idp import add_idp
from .add_idp_for_cilogon import add_idp_for_cilogon
from .check import check
from .create import create
from .edit_endpoint import edit_endpoint
from .edit_credential import edit_credential
from .edit_credentials import edit_credentials

from ..version import __version__


@click.group("gcs-migration")
@click.version_option(version=__version__)
def main() -> None:
    pass


main.add_command(create)
main.add_command(add_idps_to_storage_gateway)
main.add_command(add_idp_for_cilogon)
main.add_command(add_idp)
main.add_command(add_globus_oidc)
main.add_command(check)
main.add_command(edit_endpoint)
main.add_command(edit_credential)
main.add_command(edit_credentials)

if __name__ == "__main__":
    main()
