from typing import Optional
from typing_extensions import TypedDict

from ..util import yaml, yaml_object


class GlobusOIDCIdPDict(TypedDict):
    display_name: Optional[str]
    support_email: Optional[str]
    support_contact: Optional[str]
    server_name: Optional[str]
    certificate_path: Optional[str]
    certificate_chain_path: Optional[str]
    private_key_path: Optional[str]
    manage_certificate_and_key: Optional[bool]


@yaml_object(yaml)
class GlobusOIDCIdP:
    def __init__(self, data: Optional[GlobusOIDCIdPDict] = None) -> None:
        self.display_name: Optional[str] = None
        self.support_email: Optional[str] = None
        self.support_contact: Optional[str] = None
        self.server_name: Optional[str] = None
        self.certificate_path: Optional[str] = None
        self.certificate_chain_path: Optional[str] = None
        self.private_key_path: Optional[str] = None
        self.manage_certificate_and_key: Optional[bool] = None

        if data:
            self.__setstate__(data)

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, GlobusOIDCIdP):
            return NotImplemented

        return self is other or self.__getstate__() == other.__getstate__()

    def __getstate__(self) -> GlobusOIDCIdPDict:
        return {
            "display_name": self.display_name,
            "support_email": self.support_email,
            "support_contact": self.support_contact,
            "server_name": self.server_name,
            "certificate_path": self.certificate_path,
            "certificate_chain_path": self.certificate_chain_path,
            "private_key_path": self.private_key_path,
            "manage_certificate_and_key": self.manage_certificate_and_key,
        }

    def __setstate__(self, state: GlobusOIDCIdPDict) -> None:
        self.display_name = state["display_name"]
        self.support_email = state["support_email"]
        self.support_contact = state["support_contact"]
        self.server_name = state["server_name"]
        self.certificate_path = state["certificate_path"]
        self.certificate_chain_path = state["certificate_chain_path"]
        self.private_key_path = state["private_key_path"]
        self.manage_certificate_and_key = state["manage_certificate_and_key"]
