import pytest

from gcs_migration.models import HostEndpoint

from gcs_migration.typing.transfer_documents import (
    EndpointDocumentDict,
    EndpointServerDocumentDict,
    RoleListDocumentDict,
)


@pytest.fixture
def host_endpoint(
    host_endpoint_document: EndpointDocumentDict,
    role_list_document: RoleListDocumentDict,
    endpoint_server_document: EndpointServerDocumentDict,
) -> HostEndpoint:
    host_endpoint = HostEndpoint()
    host_endpoint.transfer_endpoint = host_endpoint_document
    host_endpoint.role_list_document = role_list_document
    host_endpoint.transfer_server_list = [endpoint_server_document]

    return host_endpoint
